'WiFi Scanner v1.5 ZS1CE
'v1.0 Graphing function available through graphrssi.html which autorefreshes
'v1.1 Now logs SSID, Date, Time & RSSI to "Date.csv" file on A: drive
'v1.2 Now checks internet connection and logs in "Date.csv" too
'v1.3 Reworked graphing fetch cycle using {JSON$} only in file and serving as html
'v1.4 Changed .csv to .txt so that you can view the text file with a browser. Fixed csv layout
'v1.5 Back to csv. Select case expanded for transmit file csv and javascript

'Auto web scan, log to file and graphing refresh currently set for 60 seconds
'and internet check set for 10 minutes - See TickMinute and TickDeciMinute below

'OPTION declarations
'===================
'  Option WEB MESSAGES ON 'Turn off status messages here for 5.07.08b12+
  Option BASE 0
  Option Escape ON

'Set the following OPTIONS at the console prompt
'===============================================
' OPTION AUTORUN ON 'Automatically recover from restarts
' OPTION TCP SERVER PORT 80, 20000 'Used for graphing. Note extended timeout
' OPTION DISPLAY 41,140 'Change to your preference noting some longer code lines below

'Get connected to the WiFi
'=========================
  If MM.Info(ip address) = "0.0.0.0" Then
    Print "Failure to connect to the Internet - Restart"
    CPU restart
  EndIf

'Set the Pico W RTC using NTP server
'===================================
  On ERROR SKIP 5
    WEB NTP -6 'Saskatoon
      If MM.Errno Then WEB NTP -6
        If MM.Errno Then WEB NTP -6
          If MM.Errno Then Print "Failure to connect to the NTP Server" : CPU RESTART

'Log program start events
'========================
  If MM.Info(EXISTS FILE "log.csv")<1 Then
    Open "log.csv" For Append As #1
    Print #1, "Date,Time,BootCount"
    Close #1
  EndIf
    Open "log.csv" For Append As #1
      Print #1,Date$ "," Time$ "," MM.Info(Boot Count)
      Close #1

'Variable declaration Area
'=========================
'Floats
  RSSI=-100'Initialise the RSSI variable
'Arrays
  Dim Integer List%(1024), Buff1%(1024)  'Longstring buffers for web scan and web server
  TickMinute=60000  'Tick every 1m to do web scan
  TickDeciMinute=600009  'Tick every 10m to do internet check

'Tick & Web declaration area
  SetTick TickMinute, MinuteLoop, 1 '1m timer
  SetTick TickDeciMinute, DeciMinuteLoop, 2  '10m timer
  WEB TCP INTERRUPT ServiceWebInterrupt 'Web server handler interrupt declaration

'Main program starts here
'========================
  RunOnce
  WEB Scan List%()
  DisplaySSIDList
  MakeSelection

'Sit and wait for exit signal
'============================
  Do While Inkey$ <> "!"
    Dummy$=Inkey$
    If Dummy$="!" Then Exit '! used to exit program. Change to suit your preference
  Loop

'Used for initial SSID listing to console
'========================================
  Sub DisplaySSIDList
    LongString Print List%()
  End Sub

'Get SSID in plain text noting that its case sensitive
'=====================================================
  Sub MakeSelection
    Input "Type in SSID to monitor (case sensitive) ", InputString$$
    InputString$=InputString$+"   " '3 spaces added to prevent selecting duplicate substring SSID
      If LInStr(List%(), InputString$) = 0 Then
        Print "No such SSID: "InputString$
        Print "Exit program and try again"
        Exit
        Exit Sub
      Else
        Print "Monitoring " InputString$
        Print "Use ";MM.Info(IP ADDRESS);"/graphrssi.html to access graphing" 'IP Address to access graphing
        Print "Wait for first RSSI before launching graphing"
      EndIf
  End Sub

'Do WiFi SSID scan every 1 minute
'================================
  Sub MinuteLoop
    WEB Scan List%()  'Get WiFi SSID list
    ExtractRSSI 'Get the targeted SSID's RSSI
    AssembleJSONString  'Assemble the JSON string for graphing of RSSI
    LogRSSI
  End Sub

'Do Internet check every 10 minutes
'==================================
  Sub DeciMinuteLoop
  Local integer Buff%(1024)
    On Error Skip
      WEB OPEN TCP CLIENT "www.Google.com", 80
        If MM.Errno Then
          Ping$="F"
        Else
          Ping$="P"
        EndIf
    WEB CLOSE TCP CLIENT
  End Sub

'Extract the RSSI for SSID from the List%()
'==========================================
  Sub ExtractRSSI
      p1%=LInStr(List%(), InputString$)
    If p1%<>0 Then
      RSSI=Val(LGetStr$(List%(),p1%+38,6))
      Print RSSI;" "; 'Output RSSI to console indicates life
    Else
      Print "No SSID: "InputString$; " found"
      Exit Sub
    EndIf
  End Sub

'-----------------------------------------------------------------------------------------
'Web server restricted to GET only for browser compatibility. POST doesn't work with Safari
'-----------------------------------------------------------------------------------------
  Sub ServiceWebInterrupt
    Local a%, p1%, p2%, file$, buff%(512)
      For a% = 1 To MM.Info(MAX CONNECTIONS)
        If Not (MM.Info(TCP Request a%)) Then Continue For 'Skip non connections
          WEB TCP READ a%, buff%()
            If LInStr(buff%(),"GET") Then p1%=LInStr(buff%(),"GET") '[GET /filename HTTP1.1] GET pointer
              p2% = LInStr(buff%(),"HTTP") 'HTTP pointer
            If p1% <> 0 And p2% <> 0 And p2%>p1% Then
              file$=LCase$(LGetStr$(buff%(), p1%+4, p2% - p1% - 5))
            EndIf
      On ERROR SKIP
        Open file$ For Input As #1 ' check that the file exists
          If Not(MM.Errno) Then
             Close #1
            Else
            WEB TRANSMIT PAGE a%,"404.html"
            WEB TRANSMIT CODE a%, 404
             Print "404"
            Exit Sub
          EndIf
      Select Case Right$(file$, 4)
        Case "html", ".htm", ".txt"
          WEB TRANSMIT PAGE a%, file$
        Case ".ico"
          WEB TRANSMIT FILE a%, file$, "image/vnd.microsoft.icon"
        Case "s.js", "s.gz"
          WEB TRANSMIT FILE a%, file$, "text/javascript"
        Case ".csv"
          WEB TRANSMIT FILE a%, file$, "text/csv"
      End Select
        EndIf
    Next a%

'Ensuring no orphan TCP connections remain
'  For a%=1 To MM.Info(max connections)
'    On error skip
'      WEB TCP Close a%
'    Next a%
  End Sub

'Assemble JSON String for graphing RSSI
'======================================
  Sub AssembleJSONString
    JSON$=""  'Clear JSON$
    JSON$="{\qa\q:"+Str$(RSSI,4,0)+"}"  '\q is " using OPTION ESCAPE
    PayLoad$=Str$(Len(JSON$)) 'Length of JSON string
  End Sub

'Run once to assemble all.html
'=============================
Sub RunOnce
  If MM.Info(EXISTS FILE "all.html") <1 Then
    Open "all.html" For Append As #1
      Print #1, "{JSON$}"
      Close #1
    Print "Should only run once"
  EndIf
End Sub

'Log RSSI to file named Date containing Time stamps and RSSI as CSV
'==================================================================
  Sub LogRSSI
    If Not(Ping$="P" Or Ping$="F") Then
      Ping$="-"
    EndIf
    On Error Skip
      If MM.Info(EXISTS FILE Date$+".csv")<1 Then
        Open Date$+".csv" For Append As #1
        Print #1, Date$ " SSID: " InputString$
        Print #1, "Time,RSSI,Ping"
        Close #1
      EndIf
    Open Date$+".csv" For Append As #1
      Print #1,Time$ "," RSSI "," Ping$
      Close #1
      Ping$="-"
  End Sub

'End of Code
